﻿using Android.App;
using Android.OS;
using Android.Support.V7.App;
using Android.Runtime;
using Android.Widget;
using Syncfusion.SfDataGrid;
using Syncfusion.SfDataGrid.DataPager;
using Android.Content;
using Android.Graphics;
using Android.Views;

namespace SFDataGridTest
{
    [Activity(Label = "@string/app_name", Theme = "@style/AppTheme", MainLauncher = true)]
    public class MainActivity : AppCompatActivity
    {
        OrderInfoRepository viewModel = new OrderInfoRepository();
        SfDataGrid sfGrid;
        SfDataPager sfPager;
        Button btn;
        protected override void OnCreate(Bundle savedInstanceState)
        {
            base.OnCreate(savedInstanceState);
            Xamarin.Essentials.Platform.Init(this, savedInstanceState);
            // Set our view from the "main" layout resource
            SetContentView(Resource.Layout.activity_main);
            sfGrid = FindViewById<SfDataGrid>(Resource.Id.sfDataGrid1);
            sfPager = FindViewById<SfDataPager>(Resource.Id.sfDataPager1);
            sfGrid.AutoGenerateColumns = false;

            GridTextColumn orderIdColumn = new GridTextColumn();
            orderIdColumn.MappingName = "OrderID";
            orderIdColumn.HeaderText = "Order ID";

            GridTextColumn customerIdColumn = new GridTextColumn();
            customerIdColumn.MappingName = "CustomerID";
            customerIdColumn.HeaderText = "Customer ID";

            GridTextColumn customerColumn = new GridTextColumn();
            customerColumn.MappingName = "Customer";
            customerColumn.HeaderText = "Customer";

            GridTextColumn countryColumn = new GridTextColumn();

            countryColumn.MappingName = "ShipCountry";
            countryColumn.HeaderText = "Ship Country";
            sfGrid.Columns.Add(new GridImageColumn() { MappingName = "Icon", HeaderText = "Note" });

            sfGrid.Columns.Add(orderIdColumn);
            sfGrid.Columns.Add(customerIdColumn);
            sfGrid.Columns.Add(customerColumn);
            sfGrid.Columns.Add(countryColumn);

            sfPager.Source = viewModel.OrderInfoCollection;
            sfPager.Orientation = ScrollOrientation.Horizontal;
            sfGrid.ItemsSource = sfPager.PagedSource;
            sfGrid.SelectionMode = SelectionMode.Single;
            sfGrid.ColumnSizer = ColumnSizer.Star;

            RegisterForContextMenu(sfGrid);

        }

        public override void OnCreateContextMenu(IContextMenu menu, View v, IContextMenuContextMenuInfo menuInfo)
        {
            // it does not trigger here
        }


        public override bool OnContextItemSelected(IMenuItem item)
        {
            // do my functions here
            return true;
        }

        private void Btn_Click(object sender, System.EventArgs e)
        {
            sfPager.Source = viewModel.OrderInfoCollection;
            sfPager.Orientation = ScrollOrientation.Horizontal;
            sfGrid.ItemsSource = sfPager.PagedSource;
            sfGrid.SelectionMode = SelectionMode.Single;
            sfGrid.ColumnSizer = ColumnSizer.Star;

        }

        public override void OnRequestPermissionsResult(int requestCode, string[] permissions, [GeneratedEnum] Android.Content.PM.Permission[] grantResults)
        {
            Xamarin.Essentials.Platform.OnRequestPermissionsResult(requestCode, permissions, grantResults);

            base.OnRequestPermissionsResult(requestCode, permissions, grantResults);
        }


    }
}